//Copyright 2013 Katarzyna Kułakowska, Tomasz Kułakowski.
//
//This file is part of SkyPig.
//
//SkyPig is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//SkyPig is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with SkyPig; if not, write to the Free Software
//Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

package model.core;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;


/**
 * @author Tomasz Kułakowski
 * @author Katarzyna Matuszewska
 *
 */
public class CropRotation {

	/*
	 * Fields:
	 */
	/**
	 *
	 */
	private static HashMap<String, CropRotation> prototypes = null;

	/**
	 *
	 */
	private String name;
	/**
	 *
	 */
	private ArrayList<String> cycle;
	/**
	 *
	 */
	private int nextVegetationIndex;

	/*
	 * Methods:
	 */
	/**
	 *
	 * @param prototypes
	 */
	public static void initialise(HashMap<String, CropRotation> prototypes) {
		if (CropRotation.prototypes == null) {
			CropRotation.prototypes = prototypes;
		}
		return;
	}

	/**
	 *
	 * @param name
	 * @param cropIndex
	 * @return
	 */
	public static CropRotation getCropRotation(String name, int cropIndex) {
		CropRotation crops = prototypes.get(name);
		CropRotation newCrop = new CropRotation(crops.name, crops.cycle);
		newCrop.nextVegetationIndex = cropIndex;
		return newCrop;
	}

	/**
	 *
	 * @param name
	 * @param cycle
	 */
	public CropRotation(String name, ArrayList<String> cycle) {
		this.name = name;
		this.cycle = cycle;
//		setNextVegetationSowingDay();
	}

	/**
	 *
	 * @return
	 */
	public String getNextVegetation() {
		String next = null;
		if (nextVegetationIndex < cycle.size() - 1) {
			next = cycle.get(nextVegetationIndex++);
		} else {
			next = cycle.get(nextVegetationIndex);
			nextVegetationIndex = 1;
		}
		return next;
	}

	/**
	 * 
	 * @return
	 */
	public String getNextVegetationName() {
		return cycle.get(nextVegetationIndex);
	}

	/**
	 *
	 * @return
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * 
	 * @return
	 */
	public int getNextVegetationIndex() {
		return nextVegetationIndex;
	}
}
