/*
//Copyright 2013 Katarzyna Kułakowska, Tomasz Kułakowski.
//
//This file is part of SkyPig.
//
//SkyPig is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//SkyPig is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with SkyPig; if not, write to the Free Software
//Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model.core;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.GregorianCalendar;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kasia
 */
public class EffectObserver extends Observer {

	double populationSize;
	ArrayList<String> results;

	/**
	 * 
	 * @param databaseName
	 */
	public EffectObserver(String databaseName) {
		super(databaseName);
		populationSize = 0.0;
		results = (ArrayList<String>) Config.getParameter("Observer_resultTypes");
		makeTable();
	}

	@Override
	public void observe(Collection<Observable> observed) {
		if (results.contains("debug")) {
			super.observe(observed);
		}
		if (World.getDate().get(Calendar.DAY_OF_YEAR) == (Integer) Config.getParameter("EffectObserver_annualSaveDay")) {
			double popSizeNow = 0;
			double firstyearSizeNow = 0;
			for (Observable o : observed) {
				try {
					Animal a = (Animal) o;
					popSizeNow++;
					if (a.getDaysSinceLaying() < 365) {
						firstyearSizeNow++;
					}
				} catch (Exception e) {
				}
			}
			if (World.getDate().get(Calendar.YEAR)
					> ((GregorianCalendar) Config.getParameter("World_startDate")).get(Calendar.YEAR)) {
				try {
					String update = "INSERT INTO pesticide_effects ("
							+ "starttime, "
							+ "year, "
							+ "pesticide, "
							+ "species, "
							+ "effect, "
							+ "effect_length, "
							+ "popsize_change, "
							+ "adults_survival, "
							+ "juveniles_peradults, "
							+ "proportion_juveniles)"
							+ " VALUES ('"
							+ Config.getParameter("startTime")
							+ "', " + World.getDate().get(Calendar.YEAR)
							+ ", " + "'" + ((ArrayList<String>) Config.getParameter("Pesticides")).get(0) + "'"
							+ ", " + "'" + (String) Config.getParameter("World_speciesName") + "'"
							+ ", " + "'" + ((ArrayList<String>) Config.getParameter("Animal_pesticidesEffects")).get(0) + "'"
							+ ", " + (Integer) Config.getParameter("Animal_pesticideEffectLength")
							+ ", " + prepareUpdate(popSizeNow / populationSize)
							+ ", " + prepareUpdate((popSizeNow - firstyearSizeNow) / populationSize)
							+ ", " + prepareUpdate((firstyearSizeNow) / populationSize)
							+ ", " + prepareUpdate((firstyearSizeNow) / popSizeNow)
							+ ");";
					addBatch(update);
					executeBatch();
				} catch (SQLException ex) {
					Logger.getLogger(SpecificObserver.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
			populationSize = popSizeNow;
		}
	}

	/**
	 * 
	 */
	public void makeTable() {
		try {
			executeStatement("CREATE TABLE IF NOT EXISTS pesticide_effects ("
					+ "starttime text, "
					+ "year integer, "
					+ "pesticide text, "
					+ "species text, "
					+ "effect text, "
					+ "effect_length integer, "
					+ "popsize_change double precision, "
					+ "adults_survival double precision, "
					+ "juveniles_peradults double precision, "
					+ "proportion_juveniles double precision, "
					+ "PRIMARY KEY (starttime, year));");
		} catch (SQLException e) {
			e.printStackTrace();
			e.getNextException().printStackTrace();
		}
	}
}
