//Copyright 2013 Katarzyna Kułakowska, Tomasz Kułakowski.
//
//This file is part of SkyPig.
//
//SkyPig is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//SkyPig is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with SkyPig; if not, write to the Free Software
//Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

package model.core;

/**
 * Specifies the methods for classes that should potentially provide information
 * stored in the database by the <code>Observer</code>.
 * 
 * @author Katarzyna Kułakowska, Tomasz Kułakowski
 * @since 2013-01-04
 */
public interface Observable {

	/*
	 * Methods:
	 */
	/**
	 * In implementing classes provides the Signature of the objects.
	 * 
	 * @return Signature of the object.
	 * @since 2013-01-04
	 */
	public Signature getSignature();
}
