//Copyright 2013 Katarzyna Kułakowska, Tomasz Kułakowski.
//
//This file is part of SkyPig.
//
//SkyPig is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//SkyPig is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with SkyPig; if not, write to the Free Software
//Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

/**
 * Provides the classes necessary for all species implemented in SkyPig model. 
 * <p>
 * Each new species should be implemented in a new package that includes 
 * classes inheriting from <code>Animal</code>, <code>LandscapeUnit</code>
 * and <code>Nest</code> and implement <code>SpeciesFactory</code>. 
 * All the other classes do not need to be implemented. 
 * </p>
 * 
 * @author Tomasz Kułakowski, Katarzyna Kułakowska
 * @since 2013-01-03
 * 
 */
package model.core;
