//Copyright 2013 Katarzyna Kułakowska, Tomasz Kułakowski.
//
//This file is part of SkyPig.
//
//SkyPig is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//SkyPig is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with SkyPig; if not, write to the Free Software
//Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

package model.woodpigeon;

import java.util.HashMap;
import model.core.Animal;
import model.core.LandscapeUnit;
import model.core.Nest;
import model.core.SpeciesFactory;


/**
 * Enables creation of proper types of Agents for woodpigeon model. 
 * 
 * @author Katarzyna Kułakowska, Tomasz Kułakowski
 * @since 2013-01-04
 */
public class WoodpigeonFactory implements SpeciesFactory {

	@Override
	public Animal createAnimal(HashMap<String, Object> parameters) {
		return new WoodpigeonAnimal(parameters);
	}

	@Override
	public Nest createNest(HashMap<String, Object> parameters) {
		return new WoodpigeonNest(parameters);
	}

	@Override
	public LandscapeUnit createLandscapeUnit(HashMap<String, Object> parameters) {
		return new WoodpigeonLandscapeUnit(parameters);
	}

}
